local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

x.LastSoulburn = GetTime()

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.TimeToDie = s.TimeToDie("target") or 10
	x.HasPandemic = s.HasSpell(131973--[[Pandemic]])
	local spec = s.Spec()
	a.Flash("Dark Intent")
	a.Flash("Pet Attack")
	a.Flash("Pet Assist")
	a.Flash("Banish")
	a.Flash("Create Healthstone", "Create Soulwell")
	a.Flash("Soulshatter")
	if spec == 1 then
		-- Affliction
		x.DoTRefresh = a.getHastedTickTime(2) - 0.1
		a.Flash("Summon Felhunter ooc")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Dark Soul: Misery",
				"Grimoire: Felhunter", "Grimoire of Sacrifice",
				"Summon Felhunter (Sacrifice down)",
				"Summon Doomguard", "Summon Terrorguard",
				"Soul Swap with Soulburn",
				"Haunt",
				"Soulburn with Dark Soul",
				"Soulburn under 20%",
				"Agony refresh early if not channeling",
				"Corruption refresh early if not channeling",
				"Unstable Affliction refresh early if not channeling",
				"Agony",
				"Corruption",
				"Unstable Affliction",
				"Drain Soul as finisher",
				"Life Tap if mana < 35%",
				"Malefic Grasp",
				"Life Tap while moving if mana < 80%",
				"Fel Flame while moving",
				"Life Tap")
	elseif spec == 2 then
		-- Demonology
		x.DoTRefresh = a.getHastedTickTime(2) - 0.1
		x.CorruptionRemaining = s.MyDebuffDuration(172--[[Corruption]], "target")
		x.TotalDoomTicks = a.getTotalTicks(4)
		x.HastedDoomTick = a.getHastedTickTime(15)
		a.Flash("Summon Felguard ooc")
		a.Flash("Carrion Swarm")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Dark Soul: Knowledge",
				"Grimoire: Felguard", "Grimoire of Sacrifice",
				"Summon Felguard (Sacrifice down)",
				"Auto Attack",
				"Felstorm", "Wrathstorm",
				"Summon Doomguard", "Summon Terrorguard",
				"Corruption (Demo)",
				"Doom",
				"Metamorphosis",
				"Cancel Metamorphosis",
				"Hand of Gul'dan",
				"Touch of Chaos if Corruption < 20sec",
				"Soul Fire",
				"Touch of Chaos",
				"Life Tap if mana < 50%",
				"Shadow Bolt",
				"Fel Flame while moving",
				"Life Tap")
	elseif spec == 3 then
		-- Destruction
		x.DoTRefresh = a.getHastedTickTime(3) - 0.1
		a.Flash("Summon Felhunter ooc")
		a.Flash("Curse of the Elements",
		        "Potion with Bloodlust or Boss HP <= 20",
		        "Dark Soul: Instability",
				"Grimoire: Felhunter", "Grimoire of Sacrifice",
				"Summon Felhunter (Sacrifice down)",
				"Summon Doomguard", "Summon Terrorguard",
				"Shadowburn",
				"Chaos Bolt",
				"Conflagrate",
				"Immolate",
				"Incinerate")
	else
		print("no active Spec")
	end
end)

